
module decode(input value, 
              input[7:0] intime, 
              output reg[90:0] manchester, 
              output reg[500:0] lman, 
              output reg[44:0] code,
              output wire[6:0] startloc) ; 
	
	reg beg;
	initial beg = 1;
	reg lastvalue;
	reg[7:0] lasttime;
	reg[2:0] thresh;
	reg[9:0] count;
	reg[3:0] same;
	reg[6:0] dcount;
	reg[6:0] mcount;
	reg[2:0] here;
	
reg changed;
	
reg reset;
	reg[6:0] limit;
  reg last;
  initial last = 0;
	//initial code = 1'b0;//b000000000000001111110000000100010010000000011;
//	initial lman = 1'b0;
//	initial manchester  = 0;
  initial count = 0;
  initial dcount = 0;
  initial mcount = 0;
	initial thresh = 1;
	initial reset = 0;
	initial changed = 0;
	reg stoprunning;
	initial stoprunning = 0;
initial limit = 45;
always @(value) begin
	if((beg == 1) || (stoprunning == 1))begin
	   lastvalue = value;
		beg = 0;
	end  
	else begin

	    if ((lastvalue != value) && (value == 1) ) begin
	        if(count > 2) begin
	          	here = 2;
	        	if ((intime -lasttime)>thresh) lman[count-1] = 1;
	        	else lman[count-1] = 0;
	        end
	        if(count > 3) begin
	         	here = 3;
	            // Correcting for slight errors
	            if ((lman[count-2] != lman[count-3]) &&(lman[count-2] != lman[count-1])) begin
	                if(lman[count-1] !=  lman[count]) lman[count-1] =  lman[count];    
	                lman[count-2] = lman[count-3];
	            end
	            
	            // Begin extracting the actual manchester encoding
	            if(count == 4) begin
	                here = 4;
	                mcount = 1;
	                manchester[mcount] = lman[count- 2];
	                same = 0;
	            end else begin
		            // Dont add another manchester bit
		            if ((manchester[mcount] == lman[count -2]) && (same < 6)) begin
		                here = 5;
		                same = same + 1;
		            end else begin  
		                 here = 6;     
	 
		                 if(dcount == limit) begin
		                    stoprunning = 1;
		                 end 
		                 changed = 0;
		                // Add another manchester bit
		                // if the manchester bit is the same as the last manchester
		               	// bit the change the value of the code bit
		                if (lman[count - 2] == manchester[mcount]) begin
		                   if(last == 1) last = 0;
		                   else last = 1;                   
		                end
		                // if the manchester bit is high add the next code bit
		                if (lman[count -2] == 1) begin
		                    code[dcount] = last;
		                    dcount = dcount + 1;
		                end
		                // Add the new manchester bit
		                mcount = mcount + 1;
		                manchester[mcount] = lman[count - 2];
		                same = 0;
		                end
		            end
            end
            lasttime= intime;
        	count = count + 1;
	            
        end
        lastvalue = value;
	end

end

interpret interpretcode(code,startloc);
endmodule


